CXX      = g++
CPPFLAGS = -I$(ROOTSYS)/include
CXXFLAGS = -w -D__osf__ -D__alpha -fPIC
LDFLAGS  = -g
SOFLAGS  = -shared -Wl,-expect_unresolved,*,-soname,

LINKDEF  = LinkDef.h
NAME     = guidemo

SOURCE := $(filter-out $(NAME)Cint.cc, $(wildcard *.cc))
OBJECTS := $(patsubst %.cc,%.o,$(SOURCE))

CLASSINCLUDES = histaction.h canvsave.h

include $(SOURCE:.cc=.d)

all: $(NAME)

$(NAME):  $(OBJECTS) $(NAME)Cint.o
	$(CXX) $(SOFLAGS)lib$(NAME).so $(LDFLAGS) $(OBJECTS) $(NAME)Cint.o \
	-o lib$(NAME).so
	@echo Library lib$(NAME).so is created

$(NAME)Cint.o: $(CLASSINCLUDES) $(LINKDEF)
	@rm -f $(NAME)Cint.cc
	@echo Generating dictionary
	rootcint $(NAME)Cint.cc -c $(CLASSINCLUDES) $(LINKDEF)
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(NAME)Cint.cc -c

(%.o): %.cc %.d
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $< -o $%

%.d: %.cc
	@$(SHELL) -ec '$(CXX) -M $(CPPFLAGS) \
	$< |sed '\''s/$*.o/& $@/g'\'' > $@'
	@echo Makefile $*.d created

clean:
	rm -f $(OBJECTS) $(NAME)Cint.* lib$(NAME).so *.d core



